/*
 * ANSI graphics decoder
 *
 * Copyright (C) 2006-2020 Magnus Bergman <magnus.bergman@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef ansi_dec_h
#define ansi_dec_h

#include <stdlib.h>                     /* free() */
#include "term_if.h"

typedef struct _AnsiDecoder AnsiDecoder;
typedef void(*AnsiDecoderCallback)(void*,const char*,int len);

AnsiDecoder* ansi_decoder_new(const TerminalInterface*,Terminal*,AnsiDecoderCallback,void*);
#define ansi_decoder_free(dec) free(dec)
int ansi_decoder_write(AnsiDecoder*,char);

#endif /* ansi_dec_h */
