#ifndef app_file_file_h
#define app_file_file_h

/* HACK to get these files included in ase_format.cc */
#include <string.h>

#include "base/file_handle.h"
#include "app/context.h"
#include "app/document.h"
#include "doc/sprite.h"

namespace app{

    class FileOp{
    private:
        FILE *_f;
        bool _oneFrame;
        Document _document;
        Context _context;
    public:
        FileOp(FILE *f):_f(f),_oneFrame(false){}

        /* Hack to avoid dealing with filenames */
        base::FileHandle filename() const { return base::FileHandle(_f); }

        bool isOneFrame() const { return _oneFrame; }

        const Context *context() const { return &_context; }
        const Document *document() const { return &_document; }

        void createDocument(doc::Sprite* s) { _document.setSprite(s); }

        bool isStop() const { return false; }

        void setError(char const* a,...);
        void setProgress(double a);
    };
}

#endif /* app_file_file_h */
