/*
 * Copyright (C) 2020 - 2023  Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#include <stddef.h>                     /* NULL */

#include "nil-pc88.h"


void
nil_pc88_default_palette(nile_t *ni)
{
    uint8_t *dst;
    int i;
    nile_ensure_palette(ni, 8, ni->bpc);
    dst = ni->palette;
    if(NILE_FORMAT_ne_r5g6b5 == ni->format){
        for(i=0;i<8;++i){
            *(uint16_t*)dst = (i&1 ? 0x1f<<0 : 0) |
                              (i&2 ? 0x1f<<11 : 0) |
                              (i&4 ? 0x3f<<5 : 0);
            dst += ni->bpc;
        }
    }else{
        int r_o = NILE_OFFSET_RED(ni->format);
        int g_o = NILE_OFFSET_GREEN(ni->format);
        int b_o = NILE_OFFSET_BLUE(ni->format);
        for(i=0;i<8;++i){
            dst[r_o] = (i&1 ? 0xff<<0 : 0);
            dst[g_o] = (i&4 ? 0xff<<0 : 0);
            dst[b_o] = (i&2 ? 0xff<<0 : 0);
            dst += ni->bpc;
        }
    }
}
