/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef converter_h
#define converter_h

#include <abydos.h>
#include <abydos-plugin.h>

#define CONVERTER_FLIP 1

typedef struct _abydos_plugin_handle_t converter_t;
struct _abydos_plugin_handle_t{
    abydos_plugin_info_t *info;
    abydos_t *ar;
    int flags;

    /* communication with child process */
    int input[2];
    int output[2];
    int pid;
    int eof;
    int result;

    /* progressive loading */
    abydos_plugin_info_func_t info_func;
    abydos_plugin_progress_func_t progress_func;
    void *userdata;
};

converter_t *abydos_converter_init(converter_t *, const char *prog, const char *mime_type, int flags);
void abydos_converter_done(converter_t *);

void abydos_converter_begin(abydos_plugin_handle_t*,abydos_plugin_info_func_t info_func,abydos_plugin_progress_func_t progress_func,void *userdata);
int abydos_converter_feed(abydos_plugin_handle_t*, const char *data, size_t len);
int abydos_converter_end(abydos_plugin_handle_t*);
cairo_surface_t *abydos_converter_get_image_surface(abydos_plugin_handle_t*,int page,cairo_bool_t *layer_visibility,int variant, double time, int frame);

#endif /* execpipe_h */
