/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef regisdec_h
#define regisdec_h

typedef struct _regis_decoder_t regis_decoder_t;
typedef struct{
    void(*position)(void*,double x,double y);
    void(*vector)(void*,double x,double y);
    void(*curve)(void*,double cx,double cy,double angle);
    void(*fill)(void*);
    void(*text)(void*);
    void(*screen)(void*);
    void(*report)(void*);
    void(*write)(void*,int color);
    void(*load)(void*);
    void(*macrograph)(void*);
}regis_interface_t;

regis_decoder_t *regis_decoder_new(const regis_interface_t *, void *userdata);
void regis_decoder_free(regis_decoder_t *dec);
void regis_decoder_data(regis_decoder_t *dec, int ch);

#endif /* regisdec_h */
