/*
 * Copyright (C) 2017  Teemu Suutari
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 */
#include <sys/types.h>

#include "common.h"

uint32_t rotateBits(uint32_t value,uint32_t count)
{
    static const uint8_t rotateNibble[16]={
        0x0,0x8,0x4,0xc,
        0x2,0xa,0x6,0xe,
        0x1,0x9,0x5,0xd,
        0x3,0xb,0x7,0xf
    };

    uint32_t ret=0;
    for (uint32_t i=0;i<count;i+=4){
        ret=(ret<<4)|rotateNibble[value&0xf];
        value>>=4;
    }
    ret>>=(4-count)&3;
    return ret;
}
