/*
 * Copyright (C) 2017  Teemu Suutari
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 */
#ifndef COMMON_HPP
#define COMMON_HPP

#include <cstdint>

constexpr bool isValidSize(uint64_t &value) noexcept
{
#if INTPTR_MAX == INT32_MAX
	return value<0x1'0000'0000ULL;
#else
	return true;
#endif
}

constexpr bool isValidSize(off_t &value) noexcept
{
#if INTPTR_MAX == INT32_MAX
	return value<0x1'0000'0000ULL;
#else
	return true;
#endif
}

uint32_t rotateBits(uint32_t value,uint32_t count);

#endif
