/*
 * Copyright (C) 2017  Teemu Suutari
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 */
#ifndef DLTADECODE_HPP
#define DLTADECODE_HPP

#include "dec.h"

class DLTADecode : public XPKDecompressor {
public:
    DLTADecode(const Buffer &packedData,std::unique_ptr<XPKDecompressor::State> &state) : XPKDecompressor(packedData) {}
    virtual ~DLTADecode(){};
    virtual void decompressImpl(Buffer &rawData,const Buffer&, bool verify) override final;

    // static method for easy external usage. Buffers can be the same for in-place replacement
    static void decode(Buffer &bufferDest,const Buffer &bufferSrc,size_t offset,size_t size);
};

#endif
