/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef loa_array_h
#define loa_array_h

#include <stddef.h>                     /* size_t */

typedef struct{
    int membersize;
    void *data;
    size_t allocation;
    int members;
}loa_array_t;

loa_array_t *loa_array_init(loa_array_t*,int membersize);
void loa_array_done(loa_array_t*);
#define loa_array_clear(a) (a)->members=0
void loa_array_ensure(loa_array_t*,int count);
void *loa_array_append(loa_array_t*,int count);
void *loa_array_insert(loa_array_t*,int pos,int count);
void loa_array_delete(loa_array_t*,int pos,int count);
#define loa_array_pop(a) (void)(--(a)->members)
#define loa_array_length(a) ((a)->members)
#define loa_array_bytes(a) ((a)->members*(a)->membersize)
#define loa_array_get(a,i) ((char*)(a)->data+((i)*(a)->membersize))
#define loa_array_index(a,p) ((((char*)p)-(char*)(a)->data)/(a)->membersize)
void *loa_array_copy(loa_array_t*);

#endif /* loa_array_h */
