/*
 * Copyright (C) 2021 - 2023  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include "nile-blit.h"
#include "nil-cga.h"

const uint8_t nil_cga_palette16[16*3] = {
    0x00, 0x00, 0x00,    /* black */
    0x00, 0x00, 0xaa,    /* dark blue */
    0x00, 0xaa, 0x00,    /* dark green */
    0x00, 0xaa, 0xaa,    /* dark cyan */
    0xaa, 0x00, 0x00,    /* dark red */
    0xaa, 0x00, 0xaa,    /* dark magenta */
    0xaa, 0x55, 0x00,    /* brown */
    0xaa, 0xaa, 0xaa,    /* light gray */
    0x55, 0x55, 0x55,    /* dark gray */
    0x55, 0x55, 0xff,    /* light blue */
    0x55, 0xff, 0x55,    /* light green */
    0x55, 0xff, 0xff,    /* light cyan */
    0xff, 0x55, 0x55,    /* light red */
    0xff, 0x55, 0xff,    /* light magenta */
    0xff, 0xff, 0x55,    /* yellow */
    0xff, 0xff, 0xff     /* white */
};

void
nil_cga_copy_palette_colors(uint8_t *dst, int dst_bpc, nile_format_t dst_format, int count)
{
    if(count > 16)
        count = 16;
    nile_blit_colors_rgb(dst, dst_bpc, dst_format, nil_cga_palette16, 3, NILE_FORMAT_r8g8b8, count);
}
