/*
 * Copyright (C) 2021  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include <string.h>

#include "nil-interlace.h"


#ifndef MIN
# define MIN(a,b) ((a)<(b)?(a):(b))
#endif


void nil_interlace_set(nile_t *dst, const uint8_t *src, int width, int height, int src_stride, int depth)
{
    int dst_stride;
    int stride;
    int y;
    nile_ensure_bitplanes(dst, width, height, depth, 1);
    dst_stride = nile_get_stride(dst);
    stride = MIN(dst_stride, src_stride);
    for(y=0;y<height;++y){
        int plane;
        for(plane=0;plane<depth;++plane)
            memcpy(dst->bitplanes[plane] + y*dst_stride,
                   src + (y * depth + plane) * src_stride,
                   stride);
    }
}
